// Copyright (c) 1997 Andrew Maltsev <am@amsoft.ru>
// All rights reserved
// 
// Dynamic object loader for Linux
//
// Tested by author only on RedHat 4.2 (2.0.30 kernel) and author is
// not an expirienced Linux programmer, there are may be errors in
// the following code -- if you find any please mail to am@amsoft.ru
//
// $Id: linux.C,v 1.1 1997/10/23 18:40:44 am Exp $
//
#include <dlfcn.h>

///////////////////////////////////////////////////////////////////////////////
// Loading (opening) shared object
//
bool
easysql_dynamic_loader::load(char const *file)
{ if(!file) return false;
  unload();
  handle=dlopen(file,RTLD_NOW);
  if(!handle)
   { set_error("loading error -- %s",dlerror());
     return false;
   }
  return true;
}

///////////////////////////////////////////////////////////////////////////////
// Unloading (closing) shared object
//
bool
easysql_dynamic_loader::unload()
{ if(handle)
   { dlclose(handle);
     handle=NULL;
   }
  return true;
}

///////////////////////////////////////////////////////////////////////////////
// Checking object
//
easysql_dynamic_loader::operator bool()
{ return bool(handle);
}

///////////////////////////////////////////////////////////////////////////////
// Returning symbol address from shared object
//
void *
easysql_dynamic_loader::symbol(char const *name)
{ if(!(*this) || !name)
   return NULL;

  void *s=dlsym(handle,name);
  if(!s)
   { set_error("can't resolve %s -- %s",name,dlerror());
     return NULL;
   }
  return s;
}
